/* eslint-disable no-continue */
/* eslint-disable default-case */
import moment from 'moment';
import { median, mode, mean } from 'mathjs';
import { v4 as uuid } from 'uuid';
import { createPaginationEmbed } from 'eris-pagination';
import { Message, User, TextChannel } from 'eris';
import { Client, Command, RichEmbed } from '../class';
import Score_Hist from './score_hist';
import Score_Notify from './score_notify';

export default class Score_Pref extends Command {
  constructor(client: Client) {
    super(client);
    this.name = 'pref';
    this.description = 'Locks or unlocks your Community Report.';
    this.usage = `${this.client.config.prefix}score pref <lock | unlock>`;
    this.subcmds = [Score_Hist, Score_Notify];
    this.permissions = 0;
    this.guildOnly = false;
    this.enabled = true;
  }

  public async run(message: Message, args: string[]) {
    try {
      if (!message.author) return this.error(message.channel, 'Member not found.');
      const score = await this.client.db.Score.findOne({ userID: message.author.id });
      if (!score) return this.error(message.channel, 'Score not calculated yet.');
      if (!score.locked) await this.client.db.Score.updateOne({ userID: message.author.id }, { $set: { locked: false } });
      switch (args[0]) {
        case 'lock':
          await this.client.db.Score.updateOne({ userID: message.author.id }, { $set: { locked: true } });
          return this.success(message.channel, 'Your report is now locked.');
        case 'unlock':
          await this.client.db.Score.updateOne({ userID: message.author.id }, { $set: { locked: false } });
          return this.success(message.channel, 'Your report is now unlocked.');
        default:
          return this.error(message.channel, 'Invalid input');
      }
    } catch (err) {
      return this.client.util.handleError(err, message, this);
    }
  }
}
